<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */
//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';;
include_once $path.'/Model_adm.php';
// Mode de compatibilité
if(!empty($_GET['server']))
{
    $_GET['nodeid'] = $_GET['server'];
}

$page_control=false;
// $webp_name doit être identique au nom de la base de données !!!
$webp_name='Server';
$webp_model='model_srv.php';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
include_once $path.'/inc/common_node_control.php';

if(!isset($_GET['action'])&&empty($_GET['action']))
{
	$_GET['action']='';
	$smarty->assign('srv_action', '');
}
try
{
	$action=$_GET['action'];
	if($action=='servicestate')
	{
		$smarty->assign('action', 'servicestate');
		//on test si le noeud est lié à une GESA
		$gesa = Model_adm::getGesaLink($dbconnection,$node->getId());
		if($gesa!=null)
		{
			session_write_close();
			$errors=array();
			$smarty->assign('srv_control_id',$node->getId());
		}
	}
	$smarty->assign('node_control_id',$node->getId());
	$descr = htmlentities($node->getDescription() , ENT_QUOTES);
	//affichage de quelques informations général sur le noeud
	$smarty->assign('srv_control_name',$server);
	$smarty->assign('srv_control_id',$node->getId());
	$smarty->assign('srv_control_IP',$node->getIPAddress());
	$smarty->assign('node_name',$node->getName() );
	$smarty->assign('node_description',$descr );
	$smarty->assign('node_group',$node->getGroup() );
	$smarty->assign('node_type',$node->getType() );
	
	$smarty->assign('srv_control_temperature',$lang['LGD_UNKNOWN']);
	$cpu = array();
}
//Traitement des exceptions SNMP et des erreurs de traitement dans la base de donnée
catch(DeviceNotAliveException $e)
{
	$smarty->assign('l_host_no_response','no');
}
catch(DeviceSNMPException $e)
{
	$smarty->assign('l_host_no_response',$lang['ADM_ERR_SNMP_FAILED']);
}
catch(DeviceException $e)
{
	$smarty->assign('l_host_no_response',$e->getMessage());
}
catch(ModelServerException $e)
{
	$smarty->assign('error_node_no_found',$node->getId());
}
//On list les plugins pour afficher les bonne couleur sur l'image du serveur
try
{
	//on récupère la liste des plugins se chargeant de tester les paramètres cruciaux du serveur (CPU,RAM,HHD)
	//Clé SRV_CPU_LOAD, SRV_HDD_LOAD,SRV_RAM_LOAD qui sont dans la table esia_configuration
	$plugin_srv=Model_server::getHealthPlugin($dbconnection);
	$list_plugin=array();
	//on récupère la liste des services
	$services = Model_esia::getServices($dbconnection,$node->getId());
	$nbr_service = count($services);
	$smarty->assign('srv_service_count',$nbr_service);
	array_multisort($services, SORT_DESC);
	$smarty->assign('cpu_img','./img/unknown.png');
	$smarty->assign('disk_img','./img/unknown.png');
	$smarty->assign('ram_img','./img/unknown.png');
	$smarty->assign('int_img','./img/unknown.png');
	$smarty->assign('cpu_msg',$lang['SRV_NO_INFORMATION']);
	$smarty->assign('disk_msg',$lang['SRV_NO_INFORMATION']);
	$smarty->assign('ram_msg',$lang['SRV_NO_INFORMATION']);
	$smarty->assign('int_msg',$lang['SRV_NO_INFORMATION']);
	$smarty->assign('cpu_id',0);
	$smarty->assign('ram_id',0);
	$smarty->assign('disk_id',0);
	$smarty->assign('int_id',0);
	
	foreach($services as $service)
	{
		
		//on format la sortie pour le HTML
		$out = preg_replace('#\|.*#','',$service['stdout']);
		//$out = preg_replace('#\n#','<br />',$out);
		$list_plugin[]=array('name'=>$service['name'],
				'state'=>$service['state'],
				'time'=>$service['last_exec_time'],
				'stdout'=>$out);
		
		//On regarde si il n'y a pas un plugin exécuté qui est taggé comme 'CPU'
		if(is_healthPlugin($service['check_plugin_name'],$plugin_srv['SRV_CPU_LOAD'])!==FALSE)
		{
			switch ($service['state'])//test de l'état du service
			{
				case 0: $smarty->assign('cpu_img','./img/ok.png');break;
				case 1: $smarty->assign('cpu_img','./img/warning.png');break;
				case 2: $smarty->assign('cpu_img','./img/critical.png'); break;
				default:$smarty->assign('cpu_img','./img/unknown.png');
			}
			$smarty->assign('cpu_msg',$out);
			$smarty->assign('cpu_id',$service['id']);
		}
		//On regarde si il n'y a pas un plugin exécuté qui est taggé comme 'HDD'
		elseif(is_healthPlugin($service['check_plugin_name'],$plugin_srv['SRV_HDD_LOAD'])!==FALSE && strpos($service['name'], 'RAM') === FALSE)
		{
			if($smarty->getTemplateVars('disk_id')==0)
			{
				switch ($service['state']) //test de l'état du service
				{
					case 0: $smarty->assign('disk_img','./img/ok.png'); break;
					case 1: $smarty->assign('disk_img','./img/warning.png'); break;
					case 2: $smarty->assign('disk_img','./img/critical.png'); break;
					default:$smarty->assign('disk_img','./img/unknown.png');
				}
				$smarty->assign('disk_msg',$out);
				$smarty->assign('disk_id',$service['id']);
			}
			else
			{
				switch ($service['state']) //test de l'état du service
				{
					case 0: $smarty->assign('disk2_img','./img/ok.png'); break;
					case 1: $smarty->assign('disk2_img','./img/warning.png'); break;
					case 2: $smarty->assign('disk2_img','./img/critical.png'); break;
					default:$smarty->assign('disk2_img','./img/unknown.png');
				}
				$smarty->assign('disk2_msg',$out);
				$smarty->assign('disk2_id',$service['id']);
			}
		}
		//On regarde si il n'y a pas un plugin exécuté qui est taggé comme 'RAM' OU Si c'est le plugin windows_storage pour la real ou physical memory
		elseif(is_healthPlugin($service['check_plugin_name'],$plugin_srv['SRV_RAM_LOAD'])!==FALSE || strpos($service['name'], 'RAM') !== FALSE)
		{
			switch ($service['state']) //test de l'état du service
			{
				case 0: $smarty->assign('ram_img','./img/ok.png'); break;
				case 1: $smarty->assign('ram_img','./img/warning.png'); break;
				case 2: $smarty->assign('ram_img','./img/critical.png'); break;
				default:$smarty->assign('ram_img','./img/unknown.png');
			}
			$smarty->assign('ram_msg',$out);
			$smarty->assign('ram_id',$service['id']);
		}
		//On regarde si il n'y a pas un plugin exécuté qui est taggé comme 'INT'
		elseif(is_healthPlugin($service['check_plugin_name'],$plugin_srv['SRV_INT_LOAD']))
		{
			if($smarty->getTemplateVars('int_id')==0)
			{
				switch ($service['state'])//test de l'état du service
				{
					case 0: $smarty->assign('int_img','./img/ok.png');break;
					case 1: $smarty->assign('int_img','./img/warning.png');break;
					case 2: $smarty->assign('int_img','./img/critical.png'); break;
					default:$smarty->assign('int_img','./img/unknown.png');
				}
				$smarty->assign('int_msg',$out);
				$smarty->assign('int_id',$service['id']);
			}
			else
			{
				switch ($service['state'])//test de l'état du service
				{
					case 0: $smarty->assign('int2_img','./img/ok.png');break;
					case 1: $smarty->assign('int2_img','./img/warning.png');break;
					case 2: $smarty->assign('int2_img','./img/critical.png'); break;
					default:$smarty->assign('int2_img','./img/unknown.png');
				}
				$smarty->assign('int2_msg',$out);
				$smarty->assign('int2_id',$service['id']);
			}
		}
	}
}
catch(ModelServerException $e)
{
	$smarty->assign('error_node_no_found',$node->getId());
}
$smarty->assign('list_plugin', $list_plugin);
//Si l'action demandé est un scannage des ports
$action=$_GET['action'];
//Variable de langue
$smarty->assign('l_information', $lang['INFORMATION_NODE']);
$smarty->assign('l_state_service', $lang['SERVICE_STATE']);
$smarty->assign('l_state_service_passifcheck', $lang['SERVICE_STATE_CHECK_PASSIF']);
$smarty->assign('l_nbr_service', $lang['ADM_NODE_SERVICE']);
$smarty->assign('l_total', $lang['TOTAL']);
$smarty->assign('l_srv_loading', $lang['SRV_LOADING']);
$smarty->assign('l_srv_int_loading', $lang['SRV_INT_LOAD']);
$smarty->assign('l_srv_interface', $lang['SRV_INTERFACE']);
$smarty->assign('l_srv_day', $lang['DAY']);
$smarty->assign('l_srv_hour', $lang['HOUR']);
$smarty->assign('l_srv_minute', $lang['MINUTE']);
$smarty->assign('l_srv_second', $lang['SECOND']);
$smarty->assign('l_show_portscanner', $lang['SRV_PORT_SCANNER']);
$smarty->assign('l_show_service', $lang['SHOW_SERVICE']);
$smarty->assign('l_show_historic', $lang['SHOW_HISTORIC']);
$smarty->assign('l_show_graph', $lang['SHOW_GRAPH']);
$smarty->assign('l_scan_all_ports', $lang['SRV_SCAN_ALL_PORTS']);
$smarty->assign('l_scan_band_port', $lang['SRV_SCAN_BAND_PORT']);
$smarty->assign('l_ctrl_lgd_title', $lang['SW_CTRL_SW_LGD_TITLE']);
$smarty->assign('l_ctrl_lgd_ok', $lang['LGD_OK']);
$smarty->assign('l_ctrl_lgd_unknown', $lang['LGD_UNKNOWN']);
$smarty->assign('l_ctrl_lgd_warn', $lang['LGD_WARN']);
$smarty->assign('l_ctrl_lgd_cri', $lang['LGD_CRI']);
$smarty->assign('l_srv_page_exe', $lang['SRV_PAGE_EXE']);
$smarty->assign('l_srv_page_exe_time', $lang['SRV_PAGE_EXE_TI']);
$smarty->assign('l_sysdescription', $lang['SYSDESCRIPTION']);
$smarty->assign('l_sysuptime', $lang['SYSUPTIME']);
$smarty->assign('l_syslocation', $lang['SYSLOCATION']);
$smarty->assign('l_syscontact', $lang['SYSCONTACT']);
$smarty->assign('l_srv_ctrl_uptime', $lang['SRV_CTRL_UPTIME']);
$smarty->assign('l_srv_ctrl_ip', $lang['SRV_CTRL_IP']);
$smarty->assign('l_srv_ctrl_cpu', $lang['SRV_CTRL_CPU']);
$smarty->assign('l_srv_ctrl_memory', $lang['SRV_CTRL_MEMORY']);
$smarty->assign('l_srv_ctrl_temperature', $lang['SRV_CTRL_TEMPERATURE']);
$smarty->assign('l_type_node', $lang['ADM_NODE_TYPE']);
$smarty->assign('l_description', $lang['ADM_DESCRIPTION']);
$smarty->assign('l_address_ip', $lang['ADM_ADDR_IP']);
$smarty->assign('l_group', $lang['ADM_GRP']);
$smarty->assign('l_device', $lang['DEVICE']);
$smarty->assign('l_device_service', $lang['ADM_NODE_SERVICE']);
$smarty->assign('l_srv_report', $lang['REPORT']);
$smarty->assign('l_modification', $lang['MODIF']);
$smarty->assign('l_interface', $lang['SRV_INTERFACE']);
$smarty->assign('l_hardware',$lang['SRV_HARDWARE']);
$smarty->assign('l_software',$lang['SRV_SOFTWARE']);
$smarty->assign('l_pattern_add_service',$lang['ADM_PATTERN_ADD_SERVICE']);
$smarty->assign('l_pattern_service_add',$lang['ADM_PATTERN_SERVICE_ADD']);


//affichage de la page
$temps = microtime();
$temps = explode(' ', $temps);
$fin = $temps[1] + $temps[0];
// On affiche la différence entre des deux valeurs
$smarty->assign('execute_time',round(($fin - $debut),6) );


if($_GET['action'] == "hardware"){
	$smarty->assign('l_storages', $lang['SRV_STORAGES']);
	$smarty->assign('l_interfaces', $lang['SRV_INTERFACES']);
	$smarty->display($template_path.'srv_hardware.html');
}
else if($_GET['action'] == "software"){
	include_once './libs/server_common.lib.php';
	$smarty->assign('is_windows',isWindows($node));

	$smarty->assign('l_system', $lang['SRV_SYSTEM']);
	$smarty->display($template_path.'srv_software.html');
}
else if($_GET['action'] == "servicestate"){
	$smarty->assign('l_cpu', $lang['SRV_CPU']);
	$smarty->assign('l_ram', $lang['SRV_RAM']);
	$smarty->assign('l_storage', $lang['SRV_STORAGE']);
	$smarty->assign('l_interface', $lang['SRV_INTERFACE']);
	$smarty->display($template_path.'srv_main.html');
}
else if($_GET['action'] == "add_checks")
{
	if($user->getAccess($dbconnection,"esia_device")&&$user->getAccess($dbconnection,"esia_administration"))
	{
	    $checks=$_POST;
		unset($checks["action"]);
		unset($checks["options"]);
		unset($checks["server"]);
		unset($checks["check"]);
		$node=Model_server::InstanceServer($dbconnection,$_GET['server']);
		$services = Model_esia::getServices($dbconnection,$node->getId());
		$plugin=Model_esia::getPlugin($dbconnection,$_POST["check"])[0];
		foreach($checks as $key => $value)
		{
		    $checks[$key]=str_replace('<$TABLE_VALUE>', $value,$_POST["options"]);
			$name=$_GET["common"]." ".$key;
			Model_adm::addService($dbconnection, $name, $plugin["id"], $node->getId(), $plugin["interval_time"], $checks[$key], $plugin["priority"],null,null);
		}
		header('Location:'.$apache_plugin_path.'/srv_control.php?server='.$node->getId());
	}
	else
	{
		
	}
	
	$page_control=true;
}
else {
	$page_control=true;
}

if($page_control){ 
    //On vérifie si l'API et ECATP sont disponibles et si on est le noeud esia
    $unity_list = false;
    if($node->getIPAddress() == '127.0.0.1' && is_readable($path.'/api/client/client.class.php')){
        try{
            include_once $path.'/api/client/client.class.php';
            $url = $_SERVER['REQUEST_SCHEME']."://127.0.0.1";
            $port = $_SERVER['SERVER_PORT'];
            $login = $user->getName();
            
            $api = new ClientApi();
            
            //le user n'a pas le hash mais si on fait un InstanceUser on récupére celui-ci
            $u = Model_esia::InstanceUser($dbconnection,$login);
            $hash = $u->getHashPassword();
            
            $api->digestauth($url,$login,$hash,$port);
            
            $ecatp_service = $api->get('system/service/ecatp-server');
            if( $ecatp_service['status'] != 'unavailable' ){
                $unity_list=true;
            }
        }
        catch(Exception $ex){}
    }
    $smarty->assign('show_unity_tab',$unity_list);
    $smarty->display($template_path.'srv_control.html');
}

function is_healthPlugin($name,$arr)
{
	foreach($arr as $pluginname)
	{
		$pluginname = preg_replace('#\%#','.*',$pluginname);
		$match ='#'.$pluginname.'#';
		
		if(preg_match($match,$name))
		{
			return true;
		}
	}
	return false;
}
function search_services($name,$arr)
{
	foreach($arr as $service)
	{
		$match ='#'.$name.'#';
		if(preg_match($match,$service['name']))
		{
			return true;
		}
	}
	return false;
}
?>
