<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once $path.'/Model_adm.php';
include_once './libs/Server.class.php';
// Mode de compatibilité
if(!empty($_GET['server']))
{
    $_GET['nodeid'] = $_GET['server'];
}

$page_control=false;
// $webp_name doit être identique au nom de la base de données !!!
$webp_name='Server';
$webp_model='model_srv.php';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
include_once $path.'/inc/common_node_control.php';
//on test si on a les autorisation d'accès
if($user->getDroits($dbconnection,"esia_administration") ==1)
{
	//on test si le noeud est lié à une GESA
	$gesa = Model_adm::getGesaLink($dbconnection,$node->getId());
	$nbrcaract=0;
	if($gesa!=null)
	{
		if($_GET['type']=='ipmi')
		{
			//on ajoute un nouveau test. 
			if($_GET['action']=='addservice')
			{
				if(isset($_POST['maxsensors']) && $_POST['maxsensors'] >0 && $_POST['maxsensors']<100)
				{
					$sensors='';
					for($i=0;$i<$_POST['maxsensors'];$i++)
					{
						if(isset($_POST[$i])&&is_numeric($_POST[$i]))
						{
							if(empty($sensors))
								$sensors=$i;
							else
								$sensors=$sensors.','.$i;
						}
					}

					$plugin = Model_esia::getPlugin($dbconnection,'GESA_IPMI_SENSORS');
					$plugin = $plugin[0];
					$param = preg_replace('#<sensors>#',$sensors,$plugin['parameter']);
					Model_adm::addService($dbconnection,'GESA_IPMI_SENSORS',$plugin['id'],$node->getId(),300000,$param,2,null,null,null,null,null);
				}
				$redirection= $arr[0]['apache_path'].'/srv_control.php?server='.$node->getName();
				header('Location: '.$redirection);
				exit();
			}
			//on récupère les capteurs déjà testé
			$checked_sensors=array();
			$services = Model_esia::getServices($dbconnection,$node->getId());
			foreach($services as $service)
			{
				if(preg_match('#GESA_IPMI#',$service['name']))
				{	
					if(preg_match('#\$IP\s+([0-9,]*)$#',$service['parameter'],$regs))
					{
			
						$arr = explode(',',$regs[1]);
						$checked_sensors = array_merge($checked_sensors,$arr);
					}
				}
			}
			//on récupère tout les capteurs
			$sensors=array();
			$link = $gesa->getName();
			if(gethostbyname($gesa->getName())==$gesa->getName())
			{
				$link = $gesa->getIPAddress();
			}
			exec(NRPE_PATH.' -H '.$link.' -p 5666 -c get_ipmi_sensor -t 50 -a '.$node->getIPAddress() ,$output);
			$i=0;
			foreach($output as $line)
			{	
				if($i!=0)
				{
					$ts = preg_split("#\|#", $line);
					//on vérifie que le capteur n'est pas déjà testé
					$graph=0;
					if(array_search($ts[0],$checked_sensors)!==false)
					{
						$graph=1;
					}
					$sensors[]=array('id'=>$ts[0],'name'=>$ts[1],'type'=>$ts[2],'state'=>$ts[3],'reading'=>$ts[4],'units'=>$ts[5],'event'=>$ts[6],'graph'=>$graph);
				}
				$i++;
			}
			$smarty->assign('sensors', $sensors);
			$smarty->assign('srvid', $node->getId());
		
			//variable de langue
			$smarty->assign('l_ipmi_id', $lang['SRV_IPMI_ID']);
			$smarty->assign('l_ipmi_name', $lang['SRV_IPMI_NAME']);
			$smarty->assign('l_ipmi_type', $lang['SRV_IPMI_TYPE']);
			$smarty->assign('l_ipmi_state', $lang['SRV_IPMI_STATE']);
			$smarty->assign('l_ipmi_unit', $lang['SRV_IPMI_UNITS']);
			$smarty->assign('l_ipmi_event', $lang['SRV_IPMI_EVENT']);
			$smarty->assign('l_ipmi_value', $lang['SRV_IPMI_VALUE']);
			$smarty->assign('l_ipmi_failed', $lang['SRV_IPMI_FAILED']);
		}
		elseif($_GET['type']=='interface')
		{
			//on ajoute un nouveau test. 
			if($_GET['action']=='addservice')
			{
				if(isset($_POST['maxsensors']) && $_POST['maxsensors'] >0 && $_POST['maxsensors']<100)
				{
					$sensors='';
					for($i=1;$i<=$_POST['maxsensors'];$i++)
					{
						if(isset($_POST[$i])&&is_numeric($_POST[$i]))
						{

							$plugin = Model_esia::getPlugin($dbconnection,'GESA_SNMP_INTERFACE_EASY');
							$plugin = $plugin[0];
							$param = preg_replace('#<ifindex>#',$_POST[$i],$plugin['parameter']);
							Model_adm::addService($dbconnection,'GESA_SNMP_INTERFACE_'.$_POST["$i-name"] ,$plugin['id'],$node->getId(),300000,$param,2,null,null,null,null,null);
						}
					}
				}
				$redirection= $arr[0]['apache_path'].'/srv_control.php?server='.$node->getName();
				header('Location: '.$redirection);
				exit();
			}
			//on récupère les interfaces déjà testée
			$checked_interface=array();
			$services = Model_esia::getServices($dbconnection,$node->getId());
			foreach($services as $service)
			{
				if(preg_match('#GESA_SNMP_INTERFACE#',$service['name']))
				{	
					if(preg_match('#\$SNMP_COM\s+([0-9]*)#',$service['parameter'],$regs))
					{
						$checked_interface[] =$regs[1];
					}
				}
			}
			//on récupère toutes les interfaces
			$interfaces=array();
			$link = $gesa->getName();
			if(gethostbyname($gesa->getName())==$gesa->getName())
			{
				$link = $gesa->getIPAddress();
			}
			exec(NRPE_PATH.' -H '.$link .' -p 5666 -c get_snmp_interface -t 50 -a '.$node->getIPAddress().' '.$node->getSNMPCommunity() ,$output);
			$i=0;;
			if(preg_match('#UNKNOWN\s+ERROR#',$output[0]))
			{
				$interfaces[]=array('id'=>'','name'=>'','description'=>$lang['SRV_LIST_SNMP_FAILED'],'ip'=>'','graph'=>1);
			}
			elseif(preg_match("#NRPE: Command 'get_snmp_interface' not defined#",$output[0]))
			{
				$interfaces[]=array('id'=>'','name'=>'','description'=>$output[0],'ip'=>'','graph'=>1);
			}
			else
			{
				foreach($output as $line)
				{	
					$ts = preg_split("#\|#", $line);
					//on vérifie que le capteur n'est pas déjà testé
					$graph=0;
					if(array_search($ts[0],$checked_interface)!==false)
					{
						$graph=1;
					}
					$interfaces[]=array('id'=>$ts[0],'name'=>$ts[1],'description'=>$ts[2],'ip'=>$ts[3],'graph'=>$graph);
				}
			}
			$smarty->assign('interfaces', $interfaces);
			$smarty->assign('srvid', $node->getId());
			//variable de langue
			$smarty->assign('l_int_id', $lang['SRV_INT_IFINDEX']);
			$smarty->assign('l_int_name', $lang['SRV_INT_NAME']);
			$smarty->assign('l_int_description', $lang['SRV_INT_DESCRIPTION']);
			$smarty->assign('l_int_ip', $lang['SRV_INT_IP']);

		}
	}
	else
	{
        if($_GET['type']=='ipmi')
		{
			//on ajoute un nouveau test. 
			if($_GET['action']=='addservice')
			{
				if(isset($_POST['maxsensors']) && $_POST['maxsensors'] >0 && $_POST['maxsensors']<100)
				{
					$sensors='';
					for($i=0;$i<$_POST['maxsensors'];$i++)
					{
						if(isset($_POST[$i])&&is_numeric($_POST[$i]))
						{
							if(empty($sensors))
								$sensors=$i;
							else
								$sensors=$sensors.','.$i;
						}
					}

					$plugin = Model_esia::getPlugin($dbconnection,'CHECK_IPMI_SENSORS');
					$plugin = $plugin[0];
					$param = preg_replace('#<sensors>#',$sensors,$plugin['parameter']);
					Model_adm::addService($dbconnection,'CHECK_IPMI_SENSORS',$plugin['id'],$node->getId(),300000,$param,2,null,null,null,null,null);
				}
				$redirection= $arr[0]['apache_path'].'/srv_control.php?server='.$node->getName();
				header('Location: '.$redirection);
				exit();
			}
			//on récupère les capteurs déjà testé
			$checked_sensors=array();
			$services = Model_esia::getServices($dbconnection,$node->getId());
			foreach($services as $service)
			{
				if(preg_match('#CHECK_IPMI#',$service['name']))
				{	
					if(preg_match('#\$IP\s+([0-9,]*)$#',$service['parameter'],$regs))
					{
			
						$arr = explode(',',$regs[1]);
						$checked_sensors = array_merge($checked_sensors,$arr);
					}
				}
			}
			//on récupère tout les capteurs
			$sensors=array();
			exec("/usr/sbin/ipmi-sensors -h ".$node->getIPv4Adress()." --config-file /etc/esia/ipmi.conf --output-sensor-state --entity-sensor-names | tr -d ' '",$output);
			$i=0;
			foreach($output as $line)
			{	
				if($i!=0)
				{
					$ts = preg_split("#\|#", $line);
					//on vérifie que le capteur n'est pas déjà testé
					$graph=0;
					if(array_search($ts[0],$checked_sensors)!==false)
					{
						$graph=1;
					}
					$sensors[]=array('id'=>$ts[0],'name'=>$ts[1],'type'=>$ts[2],'state'=>$ts[3],'reading'=>$ts[4],'units'=>$ts[5],'event'=>$ts[6],'graph'=>$graph);
				}
				$i++;
			}
			$smarty->assign('sensors', $sensors);
			$smarty->assign('srvid', $node->getId());
		
			//variable de langue
			$smarty->assign('l_ipmi_id', $lang['SRV_IPMI_ID']);
			$smarty->assign('l_ipmi_name', $lang['SRV_IPMI_NAME']);
			$smarty->assign('l_ipmi_type', $lang['SRV_IPMI_TYPE']);
			$smarty->assign('l_ipmi_state', $lang['SRV_IPMI_STATE']);
			$smarty->assign('l_ipmi_unit', $lang['SRV_IPMI_UNITS']);
			$smarty->assign('l_ipmi_event', $lang['SRV_IPMI_EVENT']);
			$smarty->assign('l_ipmi_value', $lang['SRV_IPMI_VALUE']);
			$smarty->assign('l_ipmi_failed', $lang['SRV_IPMI_FAILED']);
        }
	}
}
$smarty->display($template_path.'srv_int_ipmi.html');




?>
