<?php
/**
 * @name srv_control.php
* @description Fichier principal du plugin serveur
* @author Nicolas Biersart <n.biersart@esia-network.com>
* @contributor
* @copyright Nicolas Biersart 2012
* @license
* @esia 1.00
* @version 1.0.0
* @date 09/11/2012
*/

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once $path.'/libs/ServicesPorts.class.php';
include_once $path.'/libs/IanaiftypeMib.class.php';
include_once $path.'/libs/logo_oid.hash.php';
include_once $path.'/libs/convert.lib.php';

include_once './libs/server_common.lib.php';
//on récupère le nom du serveur
if(!empty($_GET['id']))
{
		$_GET['nodeid'] = $_GET['id'];
}
$page_control=false;
// $webp_name doit être identique au nom de la base de données !!!
$webp_name='Server';
$webp_model='model_srv.php';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
include_once $path.'/inc/common_node_control.php';
$node=Model_server::InstanceServer($dbconnection,$node->getId());
session_write_close();
if(!isset($_GET['widget'])&& empty($_GET['widget']))
{
		$_GET['widget']='';
}
try
{
	$smarty->assign("srv_control_id",$node->getId());

	if($_GET['widget'] == 'sysInfo')
	{
		$smarty->assign('widget','sysInfo');
		//print_r($lang);
		$smarty->assign('l_sysname', $lang['SRV_SYSNAME']);
		$smarty->assign('l_sysdescr', $lang['SRV_SYSDESCR']);
		$smarty->assign('l_syslocation', $lang['SRV_SYSLOCATION']);
		$smarty->assign('l_syscontact', $lang['SRV_SYSCONTACT']);

		$smarty->assign('node_sysdescr',$node->getSysDescr());
		$smarty->assign('node_syscontact',$node->getSysContact());
		$smarty->assign('node_syslocation',$node->getSysLocation());
		$smarty->assign('node_sysname',$node->getSysName());
		$smarty->assign('node_uptime',$node->getUpTime());

		$objectid = $node->getSysObjectId();
		$logo=null;
		include_once $path.'/libs/logo_oid.hash.php';
		$srv_logo=null;
		$os_type=null;
		$logo = IANA::getManufacturerLogo($objectid, $node->getSysDescr());
		if($logo['oid']!='none')
		{
			$smarty->assign('os_type', $logo['oid']);
		}
		$smarty->assign('srv_os_logo',$logo['logo']);
		$smarty->display($template_path.'srv_widget.html');
		exit(0);
	}
	else if($_GET['widget'] == 'elm')
	{
		$mode=$_GET['mode'];
		$title="SRV_".$mode;

		if($mode=="sysName")
		{
			$data=array();
			$smarty->assign("data",addtext($data,$title,$node->getSysName()));
			$smarty->display($template_path.'srv_elm.html');
		}
		else if($mode=="sysDescr")
		{
			$data=array();
			$smarty->assign("data",addtext($data,$title,$node->getSysDescr()));
			$smarty->display($template_path.'srv_elm.html');
		}
		else if($mode=="sysLocation")
		{
			$data=array();
			$smarty->assign("data",addtext($data,$title,$node->getSysLocation()));
			$smarty->display($template_path.'srv_elm.html');
		}
		else if($mode=="sysContact")
		{
			$data=array();
			$smarty->assign("data",addtext($data,$title,$node->getSysContact()));
			$smarty->display($template_path.'srv_elm.html');
		}
		else if($mode=="RAM")
		{
			$memory=$node->getMemorySize();

			preg_match('#\w*\s*:\s*(\d{1,2})%#',$memory,$matches);

			$data=array();
			addpercent($data,"RAM",$matches[1]);

			$smarty->assign("data",$data);
			$smarty->display($template_path.'srv_elm.html');
		}
		else if($mode=="CPU")
		{
			$cpus=$node->getCpuInfos();

			$min=100;
			$max=0;
			$nb=0;
			$total=0;
			foreach($cpus as $cpu){
				if($cpu["hrProcessorLoad"]<$min) $min=$cpu["hrProcessorLoad"];
				if($cpu["hrProcessorLoad"]>$max) $max=$cpu["hrProcessorLoad"];
				$total+=$cpu["hrProcessorLoad"];
				$nb++;
			}
			$average=intval($total/$nb);
			$tip=$cpus[0]['hrDeviceDescr']." | Coeurs : $nb, Minimum : $min, Maximum : $max, Moyenne : $average";

			$data=array();
			$smarty->assign("data",addpercent($data, "CPU",$average,$tip));
			$smarty->display($template_path.'srv_elm.html');
		}
	}
	else if($_GET['widget'] == 'hrSystemInfo')
	{
		$admin_ids=array();
		$data=$node->getHostSystemInfo();

		$uptime=$data[0]["hrSystemUptime"];

		$days=intval($uptime/8640000);
		$rest=$uptime%8640000;
		$hours=intval($rest/360000);
		$rest%=360000;
		$min=intval($rest/6000);

		$data[0]["hrSystemUptime"]=sprintf("%02d ".getLang("days").", %02d:%02d",$days,$hours,$min);
		$data[0]["hrSystemDate"]=DateTime::createFromFormat("Y-m-j H:i:s",($data[0]["hrSystemDate"]))->format($lang["SRV_DATETIME_FORMAT"]);

		if($data[0]["hrSystemMaxProcesses"]==0) $data[0]["hrSystemMaxProcesses"]=getLang("Unlimited");

		$data=tabLang($data,"hrSystemUptime");
		$data=tabLang($data,"hrSystemDate");
		$data=tabLang($data,"hrSystemInitialLoadParameters");
		$data=tabLang($data,"hrSystemNumUsers");
		$data=tabLang($data,"hrSystemProcesses");
		$data=tabLang($data,"hrSystemMaxProcesses");

		$stats=$data[0];
		$stat0=array_slice($stats,0,2);
		$stat1=array_slice($stats,2,2);
		$stat2=array_slice($stats,4,2);

		$smarty->assign('l_stats_title',getLang("System"));
		$smarty->assign('stats',array($stat2,$stat1,$stat0));

		//hrSWRunStatus est tout le temps en mode running sous windows 7
	//	$states=array(1=>"running","runnable","notRunnable","invalid");
		$data=$node->getProcesses();
		//print_r($data);

		for($i=0;$i<count($data);$i++){
			//$data[$i]["hrSWRunStatus"]=$states[$data[$i]["hrSWRunStatus"]];
			$data[$i]["hrSWRunParameters"] = preg_replace('#\"#','',$data[$i]["hrSWRunParameters"]);
			$data[$i]["hrSWRunPerfCPU"]/=100;
			$val = Convert\bytes($data[$i]["hrSWRunPerfMem"]*1024);
			$data[$i]["hrSWRunPerfMem"]=$val['value'].' '.$val['unity'];

			if($data[$i]['hrSWRunName']!=='')
			{
				$admin_ids[$i]=$data[$i]["hrSWRunName"];
				$defaultoptions='-H $IP -C $SNMP_COM -n <$TABLE_VALUE> -m 2000,3000 -u 90,100';
				$gesaoptions='-S $GESASN -H $NRPE_HOST -p 5666 -u -t 50 -c check_snmp_process -a $IP $SNMP_COM <$TABLE_VALUE> 2000,3000 90,100';
			}

			unset($data[$i]["hrSWRunStatus"]);
			//unset($data[$i]["hrSWRunName"]);
		}
		$data=tabLang($data,"hrSWRunName");
		$data=tabLang($data,"hrSWRunIndex");
		$data=tabLang($data,"hrSWRunPath");
		$data=tabLang($data,"hrSWRunParameters");
	//	$data=tabLang($data,"hrSWRunStatus");
		$data=tabLang($data,"hrSWRunPerfCPU");
		$data=tabLang($data,"hrSWRunPerfMem");

		$smarty->assign('l_tab_title',getLang("Processus list"));
		$smarty->assign('sort_type',array(getLang("hrSWRunPerfMem")=>"B|byte"));

		$smarty->assign('data',$data);
		$smarty->assign('id',"process");

		if($user->getAccess($dbconnection,"esia_device")&&$user->getAccess($dbconnection,"esia_administration")){
			$smarty->assign("admin_ids",$admin_ids);
			if($node instanceof RemoteServer)
			{
				$CommonName = Model_esia::getCommonName($lang, "GESA_SNMP_PROCESS", "GESA_SNMP_PROCESS");
				$smarty->assign("admin_checks",array("check"=>"GESA_SNMP_PROCESS","common"=>$CommonName,"default"=>$gesaoptions));
			}
			else
			{
				$CommonName = Model_esia::getCommonName($lang, "CHECK_SNMP_PROCESS", "CHECK_SNMP_PROCESS");
				$smarty->assign("admin_checks",array("check"=>"CHECK_SNMP_PROCESS","common"=>$CommonName,"default"=>$defaultoptions));
			}
		}

		$smarty->display($template_path.'srv_table.html');
	}
	elseif($_GET['widget'] == 'winServices'){
		$services = getWinServices($node);
		$services = minifyServices($services);

		$data = array();
		$admin_ids = array();
		foreach($services as $key => $service)
		{
			$data[$key] = array($lang['SRV_service_name']=>$service);
			$admin_ids[$key] = $service;
		}
		$smarty->assign('data',$data);
		$smarty->assign('id',"winServices");
		$smarty->assign('l_tab_title',$lang['SRV_services_list']);

		$defaultoptions='-H $IP -C $SNMP_COM -n "<$TABLE_VALUE>"';
		$gesaoptions='-S $GESASN -H $NRPE_HOST -p 5666 -u -t 50 -c check_snmp_win_service -a $IP $SNMP_COM "<$TABLE_VALUE>"';

		if($user->getAccess($dbconnection,"esia_device")&&$user->getAccess($dbconnection,"esia_administration")){
			$smarty->assign("admin_ids",$admin_ids);
			if($node instanceof RemoteServer)
			{
				$CommonName = Model_esia::getCommonName($lang, "GESA_SNMP_WIN_SERVICE", "GESA_SNMP_WIN_SERVICE");
				$smarty->assign("admin_checks",array("check"=>"GESA_SNMP_WIN_SERVICE","common"=>$CommonName,"default"=>$gesaoptions));
			}
			else
			{
				$CommonName = Model_esia::getCommonName($lang, "CHECK_SNMP_WIN_SERVICE", "CHECK_SNMP_WIN_SERVICE");
				$smarty->assign("admin_checks",array("check"=>"CHECK_SNMP_WIN_SERVICE","common"=>$CommonName,"default"=>$defaultoptions));
			}
		}
		$smarty->display($template_path.'srv_table.html');
	}
	else if($_GET['widget'] == 'storage'){
		$admin_ids=array();
		$tab_checked=array();
		$data=$node->getStorage();

		$cachedMemory=null;
		$physicalMemory=null;
		$find=0;
		$is_windows = false;

		$checked_storage=array();
		$services = Model_esia::getServices($dbconnection,$node->getId());
		foreach($services as $service)
		{
			if(preg_match('#STORAGE#',$service['check_plugin_name']))
			{
				if(preg_match('#-m\s+\"\^(.*)\"#',$service['parameter'],$regs))
				{
					$tmp=$regs[1];
					if( substr($tmp, -1) == "$")
					{
						$tmp = rtrim ( $tmp,'$');
					}
					$checked_storage[] =$tmp;
				}
			}
		}

		for($i=0;$i<count($data);$i++||$find<2)
		{
			$data[$i]["hrStorageDescr"] = preg_replace('#\"#','',$data[$i]["hrStorageDescr"]);
			if(preg_match('#[0-9A-Z]{2}\s+[0-9A-Z]{2}\s+[0-9A-Z]{2}\s+#',$data[$i]["hrStorageDescr"]))
			{
					$hexStrArr = explode(' ',$data[$i]["hrStorageDescr"]);
					$string = null;
					foreach($hexStrArr as $octet){
							$string .= chr(hexdec($octet));
					}
					$string = iconv('ASCII', 'UTF-8//IGNORE', $string);
					$data[$i]["hrStorageDescr"]=$string;
			}
			if($data[$i]["hrStorageDescr"]=="Physical memory") {
				$physicalMemory=$data[$i];
				$find++;
			}
			else if($data[$i]["hrStorageDescr"]=="Cached memory") {
				$cachedMemory=$data[$i];
				$find++;
			}

			if($data[$i]["hrStorageSize"]>0 && $data[$i]["hrStorageDescr"]!="/dev")
			{

				if($data[$i]["hrStorageDescr"]=='/' || preg_match("#(\/\w+)+#",$data[$i]["hrStorageDescr"]))
				{ //UNIX systems
					$admin_ids[$i]=$data[$i]["hrStorageDescr"];
					if(array_search($data[$i]["hrStorageDescr"],$checked_storage)!==false)
					{
						$tab_checked[$i]=1;
					}
					else
					{
						$tab_checked[$i]=0;
					}
					$gesaoptions='-S $GESASN -H $NRPE_HOST -p 5666 -u -c check_snmp_storage -a $IP $SNMP_COM "^<$TABLE_VALUE>$" 80 90';
					$defaultoptions='-H $IP -C $SNMP_COM -m "^<$TABLE_VALUE>$" -w 80% -c 90%';
				}
				elseif(preg_match('#[a-zA-Z]:\\.*#',$data[$i]["hrStorageDescr"],$matches)){ //Microsoft systems
					$admin_ids[$i]=$matches[0];
					if(array_search($matches[0],$checked_storage)!==false)
					{
						$tab_checked[$i]=1;
					}
					else
					{
						$tab_checked[$i]=0;
					}

					$gesaoptions='-S $GESASN -H $NRPE_HOST -p 5666 -u -c check_snmp_storage -a $IP $SNMP_COM "^<$TABLE_VALUE>" 80 90';
					$defaultoptions='-H $IP -C $SNMP_COM -m "^<$TABLE_VALUE>" -w 80% -c 90%';
					$is_windows=TRUE;
				}
				else {
					$admin_ids[$i]=$data[$i]["hrStorageDescr"];
					if(array_search($data[$i]["hrStorageDescr"],$checked_storage)!==false)
					{
						$tab_checked[$i]=1;
					}
					else
					{
						$tab_checked[$i]=0;
					}
					if($is_windows!=TRUE)
					{
						$gesaoptions='-S $GESASN -H $NRPE_HOST -p 5666 -u -c check_snmp_storage -a $IP $SNMP_COM "^<$TABLE_VALUE>$" 80 90';
						$defaultoptions='-H $IP -C $SNMP_COM -m "^<$TABLE_VALUE>$" -w 80% -c 90%';
					}
				}
			}
		}

		if($cachedMemory != null){
			$cachelessMemory=$physicalMemory;
			$cachelessMemory["hrStorageDescr"]="Physical without cache";
			$cachelessMemory["hrStorageUsed"]=$physicalMemory["hrStorageUsed"]-$cachedMemory["hrStorageUsed"];
			array_push($data,$cachelessMemory);
		}

		for($i=0;$i<count($data);$i++){
			$data[$i]["hrStorageSize"]*=$data[$i]["hrStorageAllocationUnits"];
			$data[$i]["hrStorageUsed"]*=$data[$i]["hrStorageAllocationUnits"];

			$data[$i]["hrStorageFreeSpace"]=$data[$i]["hrStorageSize"]-$data[$i]["hrStorageUsed"];
			if($data[$i]["hrStorageSize"]>0)
			{
				$data[$i]["hrStorageFreePercent"]=intval((100/$data[$i]["hrStorageSize"])*$data[$i]["hrStorageFreeSpace"])."%";
				$data[$i]["hrStorageUsedPercent"]=100-$data[$i]["hrStorageFreePercent"]."%";
			}
			else {
				$data[$i]["hrStorageUsedPercent"]="0%";
				$data[$i]["hrStorageFreePercent"]="0%";
			}

			$val = Convert\bytes($data[$i]["hrStorageSize"]);
			$data[$i]["hrStorageSize"]=array('raw'=>$data[$i]["hrStorageSize"]);
			$data[$i]["hrStorageSize"]['human']=$val['value'].' '.$val['unity'];

			$val = Convert\bytes($data[$i]["hrStorageFreeSpace"]);
			$data[$i]["hrStorageFreeSpace"]=array('raw'=>$data[$i]["hrStorageFreeSpace"]);
			$data[$i]["hrStorageFreeSpace"]['human']=$val['value'].' '.$val['unity'];

			$val = Convert\bytes($data[$i]["hrStorageUsed"]);
			$data[$i]["hrStorageUsed"]=array('raw'=>$data[$i]["hrStorageUsed"]);
			$data[$i]["hrStorageUsed"]['human']=$val['value'].' '.$val['unity'];
		}

		$data=tabLang($data,"hrStorageDescr",true);
		$data=tabLang($data,"hrStorageUsed");
		$data=tabLang($data,"hrStorageFreeSpace");
		$data=tabLang($data,"hrStorageSize");
		$data=tabLang($data,"hrStorageUsedPercent");
		$data=tabLang($data,"hrStorageFreePercent");
		$data=tabLang($data,"hrStorageAllocationUnits");

		$smarty->assign('data',$data);
		$smarty->assign('id',"disk");

		if($user->getAccess($dbconnection,"esia_device")&&$user->getAccess($dbconnection,"esia_administration")){
			$smarty->assign("admin_ids",$admin_ids);
			$smarty->assign("tab_hardware_checked",$tab_checked);
			if($node instanceof RemoteServer)
			{
				if($is_windows==TRUE)
				{
					$CommonName = Model_esia::getCommonName($lang, "GESA_SNMP_WINDOWS_STORAGE", "GESA_SNMP_WINDOWS_STORAGE");
					$smarty->assign("admin_checks",array("check"=>"GESA_SNMP_WINDOWS_STORAGE","common"=>$CommonName,"default"=>$gesaoptions));
				}
				else
				{
					$CommonName = Model_esia::getCommonName($lang, "GESA_SNMP_LINUX_STORAGE", "GESA_SNMP_LINUX_STORAGE");
					$smarty->assign("admin_checks",array("check"=>"GESA_SNMP_LINUX_STORAGE","common"=>$CommonName,"default"=>$gesaoptions));
				}
			}
			else
			{
				if($is_windows==TRUE)
				{
					$CommonName = Model_esia::getCommonName($lang, "CHECK_SNMP_WINDOWS_STORAGE", "CHECK_SNMP_WINDOWS_STORAGE");
					$smarty->assign("admin_checks",array("check"=>"CHECK_SNMP_WINDOWS_STORAGE","common"=>$CommonName,"default"=>$defaultoptions));
				}
				else
				{
					$CommonName = Model_esia::getCommonName($lang, "CHECK_SNMP_LINUX_STORAGE", "CHECK_SNMP_LINUX_STORAGE");
					$smarty->assign("admin_checks",array("check"=>"CHECK_SNMP_LINUX_STORAGE","common"=>$CommonName,"default"=>$defaultoptions));
				}
			}
		}

		$smarty->display($template_path.'srv_table.html');
	}
	else if($_GET['widget'] == 'interface'){
		$ifaces=$node->getInterfaces();
		$ipv4addr=array();
		try{
			$ipv4addr=$node->getIPv4Adresses();
		}catch(Exception $e){}

		$tab_checked=array();
		$states=array(1=>"up","down","testing","unknown","dormant","notPresent","lowerLayerDown");

		$data=array();
		$empty=array();
		foreach($ipv4addr[0] as $key => $value){
			$empty[$key]="";
		}

		$checked_interface=array();
		$services = Model_esia::getServices($dbconnection,$node->getId());
		foreach($services as $service)
		{
			if(preg_match('#SNMP_SW_INTERFACE_EASY#',$service['check_plugin_name']) || preg_match('#SNMP_INTERFACE_EASY#',$service['check_plugin_name']))
			{
				if(preg_match('#-i\s+([0-9]*)#',$service['parameter'],$regs))
				{
					$checked_interface[] =$regs[1];
				}
			}
		}

		for($i=0;$i<count($ifaces);$i++){
			$data[$i]=$ifaces[$i];
			for($j=0;$j<count($ipv4addr);$j++){
				if($ifaces[$i]["ifIndex"]==$ipv4addr[$j]["ipAdEntIfIndex"]){
					$data[$i]=array_merge($data[$i],$ipv4addr[$j]);
					break;
				}
			}
			if(empty($data[$i]["ipAdEntIfIndex"])) $data[$i]=array_merge($data[$i],$empty);

			$data[$i]["TypeName"]=IanaiftypeMib::getDataLinkType($data[$i]["ifType"])["name"];
			$data[$i]["TypeDesc"]=IanaiftypeMib::getDataLinkType($data[$i]["ifType"])["description"];
			preg_match("/(0x)?([0-9A-F]{12})/",strtoupper($data[$i]["ifPhysAddress"]),$matches);
			if(isset($matches[1])) $data[$i]["ifPhysAddress"]=wordwrap($matches[2],2," ",true);
			$data[$i]["ifPhysAddress"]=str_replace(" ",":",$data[$i]["ifPhysAddress"]);


			$data[$i]["ifAdminStatus"]=$states[$data[$i]["ifAdminStatus"]];
			$data[$i]["ifOperStatus"]=$states[$data[$i]["ifOperStatus"]];

			unset($data[$i]["ipAdEntIfIndex"]);
			unset($data[$i]["ifType"]);
			unset($data[$i]["ifSpeed"]);
			if(!isWindows($node)){
				if(array_search($data[$i]["ifIndex"],$checked_interface)!==false)
				{
					$tab_checked[$i]=1;
				}
				else
				{
					$tab_checked[$i]=0;
				}
				$admin_ids[$i]=$data[$i]["ifIndex"];
				$defaultoptions='-H $IP -C $SNMP_COM -i <$TABLE_VALUE> -s auto -w 70 -c 80';
				$gesaoptions='-S $GESASN -H $NRPE_HOST -p 5666 -t 50 -u -c check_snmp_interface -a $IP $SNMP_COM <$TABLE_VALUE> auto 70 80';
			}
			else
			{
				if($data[$i]['ipAdEntAddr']!=='')
				{
					if(array_search($data[$i]["ifIndex"],$checked_interface)!==false)
					{
						$tab_checked[$i]=1;
					}
					else
					{
						$tab_checked[$i]=0;
					}
					$admin_ids[$i]=$data[$i]["ifIndex"];
					$defaultoptions='-H $IP -C $SNMP_COM -i <$TABLE_VALUE> -s auto -w 70 -c 80';
					$gesaoptions='-S $GESASN -H $NRPE_HOST -p 5666 -t 50 -u -c check_snmp_interface -a $IP $SNMP_COM <$TABLE_VALUE> auto 70 80';
				}
				$regex = '/^STRING:\s"(\S+)"/';
				preg_match($regex,$data[$i]["ifName"],$matches);
				$data[$i]["ifDescr"] = $matches[1];
			}
			unset($data[$i]["ifIndex"]);
			unset($data[$i]["ifName"]);
			/*$regex='/^[0-9A-F]{2}(\s[0-9A-F]{2})';
			if(preg_match($regex,$data[$i]['ifDescr']))
			{
					$data[$i]['ifDescr']=pack('H*',str_replace(' ','',$data[$i]['ifDescr']));
			}*/
		}

		//$data=tabLang($data,"ifIndex");
		//$data=tabLang($data,"ifName");
		$data=tabLang($data,"ifDescr");
		$data=tabLang($data,"ipAdEntAddr");
		$data=tabLang($data,"ipAdEntNetMask");
		$data=tabLang($data,"ifPhysAddress");
		$data=tabLang($data,"ifOperStatus",true);
		$data=tabLang($data,"ifAdminStatus",true);
		$data=tabLang($data,"ifMtu");
		$data=tabLang($data,"TypeName");
		$data=tabLang($data,"TypeDesc");

		if(isset($admin_ids) && $user->getAccess($dbconnection,"esia_device")&&$user->getAccess($dbconnection,"esia_administration")){
			$smarty->assign("admin_ids",$admin_ids);
			$smarty->assign("tab_hardware_checked",$tab_checked);
			if($node instanceof RemoteServer)
			{
				$CommonName = Model_esia::getCommonName($lang, "GESA_SNMP_INTERFACE_EASY", "GESA_SNMP_INTERFACE_EASY");
				$smarty->assign("admin_checks",array("check"=>"GESA_SNMP_INTERFACE_EASY","common"=>$CommonName,"default"=>$gesaoptions));
			}
			else
			{
				$CommonName = Model_esia::getCommonName($lang, "CHECK_SNMP_INTERFACE_EASY", "CHECK_SNMP_INTERFACE_EASY");
				$smarty->assign("admin_checks",array("check"=>"CHECK_SNMP_INTERFACE_EASY","common"=>$CommonName,"default"=>$defaultoptions));
			}
		}

		$smarty->assign('data',$data);
		$smarty->assign('id',"interface");
		$smarty->display($template_path.'srv_table.html');
	}
	else if($_GET['widget'] == 'ip'){
		$data=$node->getIPStats();

		unset($data[0]["ipRoutingDiscards"]);

		$data[0]["ipReasmTimeout"]=$data[0]["ipReasmTimeout"]." s";

		$colin=array("ipForwDatagrams"=>"default","ipInDelivers"=>"OkNB","ipInHdrErrors"=>"ErrorsNB","ipInAddrErrors"=>"ErrorsNB","ipInUnknownProtos"=>"ErrorsNB","ipInDiscards"=>"ErrorsNB");
		$colout=array("ipOutRequests"=>"default","ipOutDiscards"=>"ErrorsNB","ipOutNoRoutes"=>"ErrorsNB");
		$colreasm=array("ipReasmTimeout"=>"default","ipReasmReqds"=>"default","ipReasmOKs"=>"OkNB","ipReasmFails"=>"ErrorsNB");
		$colfrag=array("ipFragCreates"=>"default","ipFragOKs"=>"OkNB","ipFragFails"=>"ErrorsNB");

		$grid=array(
				getLang("In")=>headerPagecolumn($colin, $data),
				getLang("Out")=>headerPagecolumn($colout, $data),
				getLang("Reasm")=>headerPagecolumn($colreasm, $data),
				getLang("Frag")=>headerPagecolumn($colfrag, $data));

		$smarty->assign('gridstats',$grid);
		$smarty->assign('l_stats_title',getLang("IP statistics"));
		$smarty->assign('id',"ip");
		$smarty->display($template_path.'srv_table.html');
	}
	else if($_GET['widget'] == 'udptable'){
		$data=$node->getUDPStats();

		$coltrs=array("udpInDatagrams"=>"OkNB","udpOutDatagrams"=>"default");
		$colerr=array("udpNoPorts"=>"ErrorsNB","udpInErrors"=>"ErrorsNB");

		$grid=array(
				getLang("Transmissions")=>headerPagecolumn($coltrs, $data),
				getLang("Errors")=>headerPagecolumn($colerr, $data));

		$smarty->assign('gridstats',$grid);
		$smarty->assign('l_stats_title',getLang("UDP statistics"));



		$data=$node->getUDPTable();
		$urls=array();

		for($i=0;$i<count($data);$i++){
			$data[$i]["PortName"]=ServicesPorts::getPort("UDP",$data[$i]["udpLocalPort"])["name"];
			$data[$i]["PortDesc"]=ServicesPorts::getPort("UDP",$data[$i]["udpLocalPort"])["description"];

			if(preg_match("#(\d{1,3}\.){3}([\d]{1,3})#", $data[$i]["udpLocalAddress"])){
				if($data[$i]["udpLocalAddress"]!="0.0.0.0")
					$urls[$i][getLang("udpLocalAddress")]="whois://".$data[$i]["udpLocalAddress"];
			}
		}

		$data=tabLang($data,"udpLocalAddress");
		$data=tabLang($data,"udpLocalPort");
		$data=tabLang($data,"PortName");
		$data=tabLang($data,"PortDesc");

		$smarty->assign('urls',$urls);
		$smarty->assign('l_tab_title',getLang("UDP table"));
		$smarty->assign('data',$data);
		$smarty->assign('id',"udptable");
		$smarty->display($template_path.'srv_table.html');
	}
	else if($_GET['widget'] == 'tcptable'){
		$data=$node->getTCPStats();

		$data[0]["tcpRtoMin"]=$data[0]["tcpRtoMin"]." ms";
		if($data[0]["tcpRtoMax"]>=0) $data[0]["tcpRtoMax"]=$data[0]["tcpRtoMax"]." ms";

		foreach($data[0] as $key => $value){
			if($data[0][$key]==-1) $data[0][$key]=getLang("Nothing");
		}

		//$smarty->assign('stats',array($stat4,$stat3,$stat2,$stat1,$stat0));
		$colnseg=array("tcpInSegs"=>"default","tcpOutSegs"=>"default","tcpRetransSegs"=>"default","tcpOutRsts"=>"default","tcpInErrs"=>"ErrorsNB");
		$colrto=array("tcpRtoMin"=>"default","tcpRtoMax"=>"default");
		$colcurr=array("tcpCurrEstab"=>"default","tcpMaxConn"=>"default");
		$colstates=array("tcpActiveOpens"=>"default","tcpPassiveOpens"=>"default","tcpEstabResets"=>"default","tcpAttemptFails"=>"ErrorsNB");

		$grid=array(
				getLang("Segments numbers")=>headerPagecolumn($colnseg, $data),
				getLang("Retransmission timeouts")=>headerPagecolumn($colrto, $data),
				getLang("Connections")=>headerPagecolumn($colcurr, $data),
				getLang("Transition states")=>headerPagecolumn($colstates, $data));

		$smarty->assign('gridstats',$grid);
		$smarty->assign('l_stats_title',getLang("TCP statistics"));

		$data=$node->getTCPTable();
		$states=array(1=>"closed","listen","synSent","synReceived","established","finWait","finWait2","closeWait","lastAck","closing","timeWait","deleteTCB");

		$urls=array();
		for($i=0;$i<count($data);$i++){
			$data[$i]["tcpConnState"]=$states[$data[$i]["tcpConnState"]];
			$data[$i]["RemPortName"]=ServicesPorts::getPort("TCP",$data[$i]["tcpConnRemPort"])["name"];
			$data[$i]["RemPortDesc"]=ServicesPorts::getPort("TCP",$data[$i]["tcpConnRemPort"])["description"];
			$data[$i]["LocalPortName"]=ServicesPorts::getPort("TCP",$data[$i]["tcpConnLocalPort"])["name"];
			$data[$i]["LocalPortDesc"]=ServicesPorts::getPort("TCP",$data[$i]["tcpConnLocalPort"])["description"];

			if(preg_match("#(\d{1,3}\.){3}([\d]{1,3})#", $data[$i]["tcpConnLocalAddress"])){
				if($data[$i]["tcpConnLocalAddress"]!="0.0.0.0")
					$urls[$i][getLang("tcpConnLocalAddress")]="whois://".$data[$i]["tcpConnLocalAddress"];
			}
			if(preg_match("#(\d{1,3}\.){3}([\d]{1,3})#", $data[$i]["tcpConnRemAddress"])){
				if($data[$i]["tcpConnRemAddress"]!="0.0.0.0")
					$urls[$i][getLang("tcpConnRemAddress")]="whois://".$data[$i]["tcpConnRemAddress"];
			}
		}

		$data=tabLang($data,"tcpConnState");
		$data=tabLang($data,"tcpConnLocalAddress");
		$data=tabLang($data,"tcpConnLocalPort");
		$data=tabLang($data,"LocalPortName");
		$data=tabLang($data,"LocalPortDesc");
		$data=tabLang($data,"tcpConnRemAddress");
		$data=tabLang($data,"tcpConnRemPort");
		$data=tabLang($data,"RemPortName");
		$data=tabLang($data,"RemPortDesc");

		$smarty->assign('urls',$urls);
		$smarty->assign('l_tab_title',getLang("TCP table"));
		$smarty->assign('data',$data);
		$smarty->assign('id',"tcptable");
		$smarty->display($template_path.'srv_table.html');
	}
}
catch(Exception $e){
	$message=$e->getMessage();
	if($e instanceof GesaConnectionFailed){
		$message=$lang["HOST_UNREACHEABLE"]." : $message";
	}
	if($e instanceof DeviceException){
		$message=$lang["HOST_UNREACHEABLE"]." : $message";
	}
	$smarty->assign("error_message",$message);
	$smarty->display($template_path.'srv_error.html');
}

function hex2str($hex) {
	$str = '';
	for($i=0;$i<strlen($hex);$i+=2)
	{
		$str .= chr(hexdec(substr($hex,$i,2)));
	}

	return $str;
}

function headerPagecolumn($names,$data){
	$ret=array();
	foreach($names as $name => $state){
		$line=array("title"=>getLang($name),"value"=>$data[0][$name],"desc"=>getLang($name."_desc"));
		if($state!="default") $line["state"]=$state;
		array_push($ret,$line);
	}
	return $ret;
}
function addtext(array &$arr,$title,$text,$tip=null,$color=null){
	array_push($arr,array("title"=>$title,"text"=>$text,"tip"=>$tip,"color"=>$color));
	return $arr;
}

function addusage(array &$arr,$title,$used,$total,$unit,$tip=null,$color=null){
	$lang=$GLOBALS["lang"];

	if($used>0) $value=(100/$total)*$used;
	else $value=0;

	if($tip==null){
		$tip=     $lang['WMI_USED_WORD']." : ".$used." ".$unit.", ";
		$tip=$tip.$lang['WMI_FREE_WORD']." : ".($total-$used)." $unit, ";
		$tip=$tip.$lang['WMI_SIZE_WORD']." : $total $unit";
	}

	return addpercent($arr, $title,$value,$tip,$color);
}

function getURLPictures(){
	if( isset($_SERVER['HTTPS'] )) $scheme="https://";
	else  $scheme="http://";

	return $scheme.$_SERVER['HTTP_HOST']."/theme/default-image/";
}

function addbartext(array &$arr,$title,$text,$type=3,$tip=null){
	$color=getURLPictures();
	switch($type){
		case 0  : $color=$color."ok.png";      break;
		case 1  : $color=$color."warning.png"; break;
		case 2  : $color=$color."critical.png"; break;
		default : $color=$color."unknown.png"; break;
	}

	array_push($arr,array("title"=>$title,"textbar"=>$text,"tip"=>$tip,"color"=>$color));
	return $arr;
}

function addpercent(array &$arr,$title,$value,$tip=null,$color=null){
	if($color==null){
		if($value<80) $color="ok.png";
		else if($value<90) $color="warning.png";
		else $color="critical.png";

		$color=getURLPictures().$color;
	}
	array_push($arr,array("title"=>$title,"value"=>$value,"tip"=>$tip,"color"=>$color));
	return $arr;
}

function tabLang($arr,$col,$data=false){
	$ret=array();
	foreach($arr as $line){
		$ret_line=array();

		if(is_int($col)) $key=array_keys($line)[$col];
		else $key=$col;

		if(isset($line[$key])) $cell=$line[$key];
		else $cell="";

		$nc=null;
		$nk = getLang($key);
		if($data) $nc=getLang($cell);

		unset($line[$key]);
		if($nk==null) $nk=$key;
		if($nc==null) $nc=$cell;

		$ret_line[$nk]=$nc;
		$ret_line=array_merge($line,$ret_line);
		array_push($ret, $ret_line);
	}
	return $ret;
}

function getLang($p){
	$lang=$GLOBALS["lang"];
	$var='SRV_'.$_GET['widget'].'_'.$p;

	if( ! array_key_exists($var,$lang)) return $p;
	return $lang[$var];
}

function minifyServices($services,$n=0)
{
    if( !is_array($services)) //On transforme en string en Array
    {
        $services = trim($services);
        $services = explode("\n",$services);
    }

    $byWords = array();
    //On parcour une première fois pour créer le tableau 1
    foreach($services as $service)
    {
        $service = trim($service);
        $words = explode(' ',$service);

        if( isset( $words[$n]) )
        {
            $key = $words[$n];
        }
        else
        {
            $key = '';
        }

        if( !isset($byWords[$key]) )
        {
            $byWords[$key] = array();
        }
        $byWords[$key][] = $service;
    }

    $byWords2 = array();

    //On vérfie le nombre de services par key. Si il y en a plusieurs, on utilise la récusion pour générer sur x+1 mots
    foreach($byWords as $words => $services)
    {
        if( count($services) == 1 )
        {
            $byWords2[$words] = $services;
        }
        else{
            $tmp = minifyServices($services,$n+1);
            foreach($tmp as $k => $v)
            {
                $byWords2["$words $k"] = $v;
            }
        }
    }

    //Si c'est la fonction parente de toutes (en récursion), on transforme le tableau $key => array() (size 1) en $key = string.
    if( $n == 0 )
    {
        $ret = array();
        foreach( $byWords2 as $words => $arr)
        {
            $words = trim($words);
            $value = array_shift($arr);

            //On ajoute un mot si on a des de, des, les ou the (< 4 chars)
            $exp = explode(' ',$words);
            $last_word = end($exp);
            if(strlen($last_word) < 4 && ctype_lower($last_word) && strlen($words) != strlen($value))
            {
                $exp2 = explode(' ',$value);
                $nb = count($exp);
                $words = $words .= ' ' . $exp2[$nb];
            }
            $ret[$words] = $value;
        }

        ksort($ret);
    }
    else
    {
        $ret = $byWords2;
    }
    return $ret;
}
?>
